<style>
  .CarrierList {
    border-bottom: 1px dashed #eee;
    padding-bottom: 5px;
    margin-bottom: 5px;
  }

  .CarrierList span {
    display: inline-block;
    margin-right: 10px;
  }

</style>
<template>
  <div class="VehicleManagement">
    <div class="head-title">
      {{isBrand?'消费品牌':'企业服务'}}管理
      <div>
        <el-button @click="checkAll=false,dialogVisible = true" style="float: right; margin-top: -25px" size="small"
          type="primary">
          批量导出
        </el-button>
      </div>
      <div>
        <el-button type="primary" style="float: right; margin: -25px 10px 0px 0px" class="el-button--small"
          @click="CommonJump('BrandEnterEdit',{isBrand:isBrand?1:0})">新增{{isBrand?'消费品牌':'企业服务'}}</el-button>
      </div>
    </div>
    <div class="content">
      <div>
        <div class="searchInput" style="width: 250px; margin-bottom: 10px">
          <el-input @keyup.enter.native="(msg.pageIndex = 1), getList()" @clear="(msg.pageIndex = 1), getList()"
            style="display: inline-block; width: 225px; height: 30px" :placeholder="`${isBrand?'消费品牌':'企业服务'}名称`"
            v-model="msg.BrandName" size="small" clearable>
          </el-input>
          <span @click="(msg.pageIndex = 1), getList()" class="el-icon-search" style="
              color: #979dad;
              font-size: 14px;
              position: relative;
              top: 1px;
            "></span>
        </div>
        <div class="searchInput" style="width: 200px; margin-bottom: 10px">
          <el-select size="small" v-model="msg.CategoryId" filterable @change="(msg.pageIndex = 1), getList()"
            :placeholder="`${isBrand?'消费品牌':'企业服务'}分类`" clearable @clear="(msg.pageIndex = 1), getList()">
            <el-option v-for="item in CategoryList" :key="item.ID" :label="item.ClassName" :value="item.ID">
            </el-option>
          </el-select>
        </div>
      </div>
      <el-table :data="tableData" v-loading="loading" border style="width: 100%; margin: 20px 0">
        <el-table-column prop="Id" label="ID" width="100">
          <template slot-scope="scope">
            <span @click="goRecruit(scope.row.ID)">{{ scope.row.ID }}</span>
          </template>
        </el-table-column>
        <el-table-column prop="BrandName" :label="`${isBrand?'品牌':'服务'}名称`"> </el-table-column>
        <el-table-column prop="Logo" label="Logo" width="100">
          <template slot-scope="scope">
            <el-image v-if="scope.row.Logo" :src="scope.row.Logo" style="width: 50px"
              :preview-src-list="scope.row.LogoList">
            </el-image>
          </template>
        </el-table-column>
        <el-table-column prop="CategoryName" :label="`${isBrand?'品牌':'服务'}分类`" width="150">
        </el-table-column>
        <el-table-column prop="ShopNum" label="店铺数量" width="80">
        </el-table-column>
        <el-table-column prop="BuiltUpArea" label="需求面积" width="100">
          <template slot-scope="scope">
            <span>{{ scope.row.AreaRequirement }} ㎡</span>
          </template>
        </el-table-column>
        <!-- <el-table-column prop="ProjectName" label="商铺性质" width="150">
        </el-table-column> -->
        <el-table-column prop="BrandType" :label="`${isBrand?'品牌':'服务'}定位`" width="180">
        </el-table-column>
        <el-table-column prop="CustomerType" label="客群定位" width="180">
        </el-table-column>
        <el-table-column prop="ContactName" label="联系人" width="120">
        </el-table-column>
        <el-table-column prop="ContactPhone" label="联系电话" width="150">
        </el-table-column>
        <el-table-column fixed="right" label="操作" width="120" v-if="!readonly">
          <template slot-scope="scope">
            <el-tooltip class="item" effect="dark" content="编辑" placement="top">
              <img @click="CommonJump('BrandEnterEdit', { ID: scope.row.ID,isBrand:isBrand?1:0 })"
                src="../../assets/img/setup/edit.png" alt="" class="imgstyle" />
            </el-tooltip>
            <el-tooltip class="item" effect="dark" content="删除" placement="top">
              <img @click="delManage(scope.row)" src="../../assets/img/setup/del.png" alt="" class="imgstyle" />
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>
      <el-pagination style="text-align: right" background @current-change="handleCurrentChange"
        :page-size="msg.pageSize" :current-page.sync="msg.pageIndex" layout="total,prev, pager, next" :total="total">
      </el-pagination>
    </div>

    <!-- 选择导出信息 -->
    <el-dialog title="选择导出信息" :visible.sync="dialogVisible" width="960px">
      <div v-loading="downLoadLoading" :element-loading-text="loadingText">
        <el-form style="border: 1px solid #f0f2f7" :model="addMsg" ref="addMsg" label-width="100px">
          <div style="
            box-sizing: border-box;
            background-color: #f3f5f6;
            width: 100%;
            padding-left: 20px;
            height: 50px;
            line-height: 50px;
          ">
            <el-checkbox :indeterminate="isIndeterminate" v-model="checkAll" @change="handleCheckAllChange">全选
            </el-checkbox>
          </div>
          <div style="margin: 15px 0"></div>
          <div style="padding: 10px 25px 20px">
            <el-checkbox-group v-model="checkedCities" @change="handleCheckedCitiesChange">
              <el-checkbox style="margin-bottom: 10px; width: 135px" v-for="city in cities" :label="city.Id"
                :key="city.Name">
                {{ city.Name }}</el-checkbox>
            </el-checkbox-group>
          </div>
        </el-form>
        <div style="text-align: right; margin-top: 20px">
          <el-button size="small" type="primary" @click="downLoadCarrier">导出</el-button>
        </div>
      </div>
    </el-dialog>
  </div>
</template>
<script>
  import {
    setInterval,
    clearInterval
  } from 'timers';
  export default {
    data() {
      return {
        msg: {
          BrandName: "", //名称
          pageIndex: 1,
          pageSize: 15,
          CarrierName: "", //载体名称
          MetroNum: "", //地铁线路
          Developers: "", //开发商
          QStartDate: "", //开业开始时间
          QEndDate: "", //	开业截止时间
          ExcelEnumIds: [],
          UserId: 0,
          RandomNum: 0, //随机数
          CategoryId: "", //分类Id
          BrandEnterpriseType: null, //(1-品牌，2-服务)
          OpeningStatus: -1, // 0-即将开业，1-已开业
          QShopType: 0, //1-成都首店,2-宜宾商载通
        },
        addMsg: {},
        dialogVisible: false,
        dateStr: [], //日期
        total: 0,
        tableData: [], //数据列表
        isShowAdd: false, //新增修改载体
        ProjectTypeList: [], //项目类型
        checkAll: false,
        checkedCities: [],
        cities: [],
        cityOptions: [],
        isIndeterminate: false,
        downLoadLoading: false, //导出Loading
        download_timer: null, //下载文件timer
        loadingText: "", //下载文件提示名称
        isBrand: true,
        CategoryList: [],
        readonly: false,
      };
    },
    created() {
      if (this.$route.query && this.$route.query.readonly) {
        this.readonly = this.$route.query.readonly;
      }
      this.isBrand = this.$route.name == 'BrandEnterpriseManager'
      this.msg.BrandEnterpriseType = this.isBrand ? 1 : 2
      this.getList();
      this.getTypeEnumList();
      this.getDown();
    },
    watch: {
      $route: {
        handler(val, oldVal) {
          if (this.$route.query && this.$route.query.readonly) {
            this.readonly = this.$route.query.readonly;
          }
          this.isBrand = val.name == 'BrandEnterpriseManager'
          this.msg = {
            BrandName: "", //名称
            pageIndex: 1,
            pageSize: 15,
            CategoryId: "", //分类Id
            BrandEnterpriseType: this.isBrand ? 1 : 2, //(1-品牌，2-服务)
          }
          this.getList();
          this.getTypeEnumList();
        },
        deep: true,
      },
    },
    methods: {
      getList() {
        this.loading = true;
        if (this.dateStr && this.dateStr.length > 0) {
          this.msg.QStartDate = this.dateStr[0];
          this.msg.QEndDate = this.dateStr[1];
        } else {
          this.msg.QStartDate = "";
          this.msg.QEndDate = "";
        }
        this.apipost("/api/Trade/GetBrandEnterprisePage", this.msg, (res) => {
          this.loading = false;
          if (res.data.resultCode == 1) {
            this.total = res.data.data.count;
            let pageData = res.data.data.pageData;
            this.tableData = pageData;
            this.tableData.forEach((x) => {
              x.LogoList = [];
              x.LogoList.push(x.Logo);
            });
          }
        });
      },
      handleCheckAllChange(val) {
        this.checkedCities = val ? this.cityOptions : [];
        this.isIndeterminate = false;
      },
      handleCheckedCitiesChange(value) {
        let checkedCount = value.length;
        this.checkAll = checkedCount === this.cities.length;
        this.isIndeterminate =
          checkedCount > 0 && checkedCount < this.cities.length;
      },
      //下载载体文件
      downLoadCarrier() {
        this.msg.ExcelEnumIds = this.checkedCities;
        let msg = JSON.parse(JSON.stringify(this.msg));
        msg.RandomNum = Math.random();
        if (!msg.Id || msg.Id == "") {
          msg.Id = 0;
        }
        this.downLoadLoading = true;
        if (this.isBrand) {
          this.loadingText = "正在生成消费品牌文件,请勿关闭或刷新页面...";
        } else {
          this.loadingText = "正在生成服务文件,请勿关闭或刷新页面...";
        }
        var that = this;
        this.download_timer = setInterval(function () {
          that.checkCarrierFile(msg)
        }, 2000);
      },
      checkCarrierFile(msg) {
        var fileName = "企业服务信息.xls";
        if (this.isBrand) {
          fileName = "消费品牌信息.xls";
        }
        var that = this;
        this.apipost(
          "/api/Trade/CheckBrandEnterpriseFile",
          msg,
          (res) => {
            if (res.data.resultCode == 1) {
              clearInterval(this.download_timer);
              this.checkedCities = [];
              if (this.isBrand) {
                this.loadingText = "正在下载消费品牌文件,请勿关闭或刷新页面...";
              } else {
                this.loadingText = "正在下载企业服务文件,请勿关闭或刷新页面...";
              }
              var fileUrl = res.data.data.fileUrl;
              var filepath = res.data.data.filePath;
              var key = res.data.message;
              var params = {
                fileUrl: fileUrl
              }
              //删除缓存和Key
              var deleteparams = {
                key: key,
                fileUrl: fileUrl,
                filepath: filepath,
              };
              var apiurl = that.domainManager().DomainUrl + "/api/Trade/GetFile";
              var postData = that.GetPostData("", params, "");
              that.$http.post(apiurl, postData, {
                responseType: 'arraybuffer',
                onDownloadProgress: (progressEvent) => {
                  const progress = Math.round((progressEvent.loaded / progressEvent.total) * 100);
                  that.loadingText = `正在下载【` + (that.isBrand ? '消费品牌' : "企业服务") + `】文件` + progress +
                    `%,请勿关闭或刷新页面...`;
                  // 在这里处理下载进度, 如更新界面上的进度条
                }
              }).then((res) => {
                let blob = new Blob([res.data], {
                  type: "application/vnd.ms-excel"
                })
                let url = URL.createObjectURL(blob);
                let link = document.createElement('a');
                link.href = url;
                link.setAttribute("download", fileName);
                document.body.appendChild(link);
                link.click();
                that.downLoadLoading = false;
                that.loadingText = "";
                that.apipost("/api/Trade/DeleteKey", deleteparams, (res) => {})
                that.dialogVisible = false;
              }).catch(function (res) {
                console.log(res);
              });
            }
          }
        );
      },

      getDown() {
        this.cityOptions = [];
        this.apipost("/api/Trade/GetBrandEnterpriseExportEnumList", {}, (res) => {
          this.cities = res.data.data;
          let data = res.data.data;
          data.forEach((item) => {
            this.cityOptions.push(item.Id);
          });
        });
      },

      //删除
      delManage(obj) {
        let that = this;
        that.Confirm("是否删除?", function () {
          that.apipost(
            "/api/Trade/RemoveBrandEnterpriseInfo", {
              ID: obj.ID,
            },
            (res) => {
              if (res.data.resultCode == 1) {
                that.Success(res.data.message);
                that.getList();
              } else {
                that.Error(res.data.message);
              }
            }
          );
        });
      },
      handleCurrentChange(val) {
        this.msg.pageIndex = val;
        this.getList();
      },
      //获取项目类型
      getTypeEnumList() {
        this.apipost("/api/Trade/GetBrandEnterpriseExportEnumList", {}, (res) => {
          if (res.data.resultCode == 1) {
            this.ProjectTypeList = res.data.data;
          }
        });
        this.apipost("/api/Trade/GetBrandClassList", {
          BrandCategory: this.isBrand ? 3 : 4
        }, (res) => {
          if (res.data.resultCode == 1) {
            this.CategoryList = res.data.data;
          }
        });
      },
      //获取项目类型
      getProject(type) {
        let str = "";
        this.ProjectTypeList.forEach((x) => {
          if (x.Id == type) {
            str = x.Name;
          }
        });
        return str;
      },
    },
    mounted() {},
  };

</script>
<style>
  .VehicleManagement .content .searchInput {
    border: 1px solid #dcdfe6;
    border-radius: 4px;
  }

  .VehicleManagement .content .searchInput .el-input__inner {
    border: none;
    outline: none;
    height: 30px;
    line-height: 30px;
  }

  .VehicleManagement .content .searchInput {
    line-height: normal;
    display: inline-table;
    width: 100%;
    border-collapse: separate;
    border-spacing: 0;
    width: 250px;
    margin-right: 20px;
  }

  .VehicleManagement .content {
    background: #fff;
    margin-top: 10px;
    padding: 20px;
    box-sizing: border-box;
  }

</style>
